<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Elemente innerhalb eines Elternelements finden</title>
<meta name="author" content="Bieling Peter">
<meta name="generator" content="Ulli Meybohms HTML EDITOR">
<link rel="stylesheet" href="source.css" type="text/css">
</head>
<body>
<h2>copy_brench()</h2>
<h3>RSS-Item mit bestimmtem Inhalt finden</h3>
<p>Das folgende Beispiel soll zeigen, wie es mglich ist, RSS-Feeds
nach bestimmten Keywords zu filtern.</p>
<p>Unser Beispielfeed sieht so aus:</p>
<?php
require_once("../xml-line.php");
$mylines = new xml_line("rss.xml", "hixml");
$mylines->xml_stream();
// Inhalt de Puffers ausgeben:
echo $mylines->get_output();

?>
<p>Zunchst suchen wir ein RSS-Item, dessen <i>description</i> das Wort
<i>Fisch</i> enthlt.</p>
<pre class="source"><span class="html">
<span class="default">&lt;?php
</span><span class="keyword">require_once(</span><span class="string">"xml-line.php"</span><span class="keyword">);
</span><span class="default">$mylines </span><span class="keyword">= new </span><span class="default">xml_line</span><span class="keyword">(</span><span class="string">"rss.xml"</span><span class="keyword">);
</span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">get_data</span><span class="keyword">(</span><span class="default">0</span><span class="keyword">,</span><span class="string">"rss/channel/item/description"</span><span class="keyword">,</span><span class="string">"Fisch"</span><span class="keyword">);
</span><span class="default">$result</span><span class="keyword">=</span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">xml_stream</span><span class="keyword">();
echo </span><span class="string">"&lt;pre&gt;"</span><span class="keyword">;
echo </span><span class="default">htmlentities</span><span class="keyword">(</span><span class="default">print_r</span><span class="keyword">(</span><span class="default">$result</span><span class="keyword">, </span><span class="default">true</span><span class="keyword">));
echo </span><span class="string">"&lt;/pre&gt;"</span><span class="keyword">;
</span><span class="default">?&gt;</span>
</span>
</pre>

<?php
require_once("../xml-line.php");
$mylines = new xml_line("rss.xml");
$mylines->get_data(0,"rss/channel/item/description","Fisch");
$result=$mylines->xml_stream();
echo "<pre>";
echo htmlentities(print_r($result, true));
echo "</pre>";
?>
<p>Der Einfachheit halber gehen wir mal davon aus, dass es nur ein Ergebnis gibt.
Den Zhlpfad zum gefundenen description-Element finden wir in $result[0][0][4].</p>

<p>Daraus ergibt sich folgender Code-Block:</p>
<pre class="source"><span class="html">
<span class="default">&lt;?php
</span><span class="keyword">if (isset(</span><span class="default">$result</span><span class="keyword">[</span><span class="default">0</span><span class="keyword">][</span><span class="default">0</span><span class="keyword">][</span><span class="default">4</span><span class="keyword">])) {
    require_once(</span><span class="string">"xml-line.php"</span><span class="keyword">);
    </span><span class="default">$mylines </span><span class="keyword">= new </span><span class="default">xml_line</span><span class="keyword">(</span><span class="string">"rss.xml"</span><span class="keyword">);
    </span><span class="comment">//Den Zhlpfad aufsplitten:
    </span><span class="default">$tmp_array</span><span class="keyword">=</span><span class="default">explode</span><span class="keyword">(</span><span class="string">'-'</span><span class="keyword">,</span><span class="default">$result</span><span class="keyword">[</span><span class="default">0</span><span class="keyword">][</span><span class="default">0</span><span class="keyword">][</span><span class="default">4</span><span class="keyword">]);
    </span><span class="default">$nr</span><span class="keyword">=</span><span class="default">$tmp_array</span><span class="keyword">[</span><span class="default">2</span><span class="keyword">]; </span><span class="comment">//Zhler fr den item-Block auslesen
    </span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">copy_brench</span><span class="keyword">(</span><span class="default">0</span><span class="keyword">,</span><span class="string">"rss/channel/item"</span><span class="keyword">, </span><span class="string">""</span><span class="keyword">,</span><span class="string">""</span><span class="keyword">,</span><span class="string">"1-1-$nr"</span><span class="keyword">);
    </span><span class="default">$result2</span><span class="keyword">=</span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">xml_stream</span><span class="keyword">();
    </span><span class="default">$found_item </span><span class="keyword">= </span><span class="default">$result2</span><span class="keyword">[</span><span class="default">0</span><span class="keyword">][</span><span class="default">0</span><span class="keyword">][</span><span class="default">0</span><span class="keyword">];
    echo </span><span class="string">"&lt;pre&gt;"</span><span class="keyword">;
    echo </span><span class="default">htmlentities</span><span class="keyword">(</span><span class="default">$found_item</span><span class="keyword">);
    echo </span><span class="string">"&lt;/pre&gt;"</span><span class="keyword">;
}
</span><span class="default">?&gt;</span>
</span>
</pre>
<?php
if (isset($result[0][0][4])) {
	require_once("../xml-line.php");
	$mylines = new xml_line("rss.xml");
	//Den Zhlpfad aufsplitten:
	$tmp_array=explode('-',$result[0][0][4]);
	$nr=$tmp_array[2]; //Zhler fr den item-Block auslesen
	$mylines->copy_brench(0,"rss/channel/item", "","","1-1-$nr");
	$result2=$mylines->xml_stream();
	$found_item = $result2[0][0][0];
	echo "<pre>";
	echo htmlentities($found_item);
	echo "</pre>";
}
?>
<p>Das gesuchte <i>item</i>-Element befindet sich jetzt in $found_item.
Man knnte es jetzt in einen anderen RSS-Feed einsetzen.
Normalerweise wre solch eine Abfrage natrlich komplexer. Man mchte ja nicht nur
die <i>description</i> sondern auch den <i>title</i> durchsuchen. Auerdem muss eine Schleife
eingebaut werden, fr den Fall, dass der Begriff hufiger gefunden wird.
Dennoch sollte das Prinzip klar geworden sein.
</p>
</body>
</html>