<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Die Methode get_record</title>
<meta name="author" content="Bieling Peter">
<meta name="generator" content="Ulli Meybohms HTML EDITOR">
<link rel="stylesheet" href="source.css" type="text/css">


</head>
<body>
<h3><a name="up">XML</a> in Tabellenstruktur einlesen</h3>
<h4 class="methode">Methode: get_record()</h4>
<p class="anmerkung">Diese Methode ist besonders dazu gedacht, einen schnellen Zugriff
auf XML-Dateien zu erhalten, die im Grunde <i>flache</i> Tabellen sind, und eventuell
sogar nichts anderes als ein XML-Export aus einer Datenbanktabelle oder Tabellenkalkulation sind.
</p>
<?php
require_once("../xml-line.php");
$mylines = new xml_line("xml-files/adressen.xml", "hixml");
$mylines->get_record(0,"eintrag");
$mylines->xml_stream();
print $mylines->get_output();
?>

<p>Dieses Beispiel macht es sich etwas schwerer, da auch Attribute und sogar ein
Element mit untergeordneten Elementen enthalten sind.</p>
<p>Aufgabe: Alle Datenstze aus der Datei <i>adressen.xml</i> einlesen, die mit
dem Tag <i>eintrag</i> eingeschlossen sind.</p>

<pre class="source"><code><span class="html">
<span class="default">&lt;?php
</span><span class="keyword">require_once(</span><span class="string">"../xml-line.php"</span><span class="keyword">);
</span><span class="default">$mylines </span><span class="keyword">= new </span><span class="default">xml_line</span><span class="keyword">(</span><span class="string">"xml-files/adressen.xml"</span><span class="keyword">, </span><span class="string">"hixml"</span><span class="keyword">);
</span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">get_record</span><span class="keyword">(</span><span class="default">0</span><span class="keyword">,</span><span class="string">"eintrag"</span><span class="keyword">);
</span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">xml_stream</span><span class="keyword">();
print </span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">get_output</span><span class="keyword">();
</span><span class="default">?&gt;</span>
</span>
</code></pre>


<p>Ergebnis-Array:</p>
<pre class="source"><code><span class="html">
<span class="default">&lt;?php
</span><span class="keyword">echo </span><span class="string">"&lt;pre&gt;"</span><span class="keyword">;
</span><span class="default">print_r</span><span class="keyword">(</span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">table_result</span><span class="keyword">);
echo </span><span class="string">"&lt;/pre&gt;"</span><span class="keyword">;
</span><span class="default">?&gt;</span>
</span>
</code></pre>

<?php
echo "<pre>";
print_r($mylines->table_result);
echo "</pre>";
?>

<p>Besonderheit: Die Zuordung von Attributen geschieht folgendermaen:<br>
<span class='elname'>['eintrag@datum']</span></p>
<p>Enthlt ein Element des Datensatzes ein weiteres Element, wird dies
folgendermaen in die Tabellenstruktur eingegliedert:<br>
<span class='elname'>['anschrift/strasse']</span>
</p>
<p>Die get-record-Methode hat natrlich ihre Grenzen und eignet sich vor allem
fr Tabellen- oder Datenbankexporte. Wie in einer
Datenbanktabelle muss jede Spalte einen anderen Namen haben. Wrde hier ein
gleichnamiges Element auftauchen, wrde der vorige Wert berschrieben werden.</p>


<h4>Zugriff auf einzelne Werte:</h4>
<p>Aufgabe: Welchen Wert hat das Element <b>name</b> im zweiten Datensatz? Das Ergebnis-Array
steckt in der Variablen <b>table_result</b>.</p>
<pre class="source"><code><span class="html">
<span class="default">&lt;?php
printf</span><span class="keyword">(</span><span class="string">"&lt;p&gt;Der Wert ist: &lt;b&gt;%s&lt;/b&gt;&lt;/p&gt;"</span><span class="keyword">,
       </span><span class="default">$mylines</span><span class="keyword">-&gt;</span><span class="default">table_result</span><span class="keyword">[</span><span class="default">0</span><span class="keyword">][</span><span class="default">1</span><span class="keyword">][</span><span class="string">'name'</span><span class="keyword">]);
</span><span class="default">?&gt;</span>
</span>
</code></pre>

<?php
printf("<p>Der Wert ist: <b>%s</b></p>",
       $mylines->table_result[0][1]['name']);
?>
<p>Noch einmal zur Erinnerung: Der erste Index zhlt die aufgerufenen Methoden.
In diesem Beispiel gibt es nur die eine, also [0]. Der Index [1] ist das zweite
zurckgelieferte Ergebnis, da wir auch hier bei 0 anfangen zu zhlen.</p>
<p class="link"><a href="../index.html">Zur Einleitung</a>
<a href="#up"><img src="../up.gif" width="44" height="23" border="0" alt=""></a></p>
</body>
</html>